#include "tsbrowse4.h"
#pragma hdrstop

#include "tsb4_f_tools.h"
#include "tsb4_f_module.h"
#include "tsb4_f_mainm.h"
#include "tsb4_f_pnot.h"
#include "tsb4_f_resourcefile.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TToolsForm *ToolsForm;
//---------------------------------------------------------------------------
__fastcall TToolsForm::TToolsForm(TComponent* Owner)
        : TForm(Owner)
{ 
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::CloseProjectClick(TObject *Sender)
{ tools->CloseProject();

}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenProjectClick(TObject *Sender)
{
tools->OpenProject(tOpenProject->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenProjectInfoClick(TObject *Sender)
{
tools->OpenProjectInfo(tOpenProjectInfo->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::SaveProjectClick(TObject *Sender)
{
tools->SaveProject();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::CloseFileClick(TObject *Sender)
{
tools->CloseFile(tCloseFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::OpenFileClick(TObject *Sender)
{
tools->OpenFile(tOpenFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::ReloadFileClick(TObject *Sender)
{
tools->ReloadFile(tReloadFile->Text);
}
//---------------------------------------------------------------------------

class TAutoModuleCreator : public TIModuleCreatorEx
{
public:
  __fastcall TAutoModuleCreator(TToolsForm *af) : TIModuleCreatorEx() {f=af;}
  TToolsForm *f;
  //
  bool __stdcall Existing() {return f->cExisting->Checked;}
  AnsiString __stdcall GetAncestorName() {return f->AncestorClass->Text;}
  AnsiString __stdcall GetFileName() {return f->SourceFileName->Text;}
  AnsiString __stdcall GetIntfName() {return f->HeaderFileName->Text;}
  AnsiString __stdcall GetFileSystem() {return f->FileSystem->Text;}
  AnsiString __stdcall GetFormName() {return f->ModuleName->Text;}
  void __stdcall FormCreated(TIFormInterface *newfi) {}
  AnsiString __stdcall NewModuleSource(const AnsiString uid,const AnsiString fid,const AnsiString aid) {return f->Source->Lines->Text;}
  AnsiString __stdcall NewIntfSource(const AnsiString uid,const AnsiString fid,const AnsiString aid)   {return f->HeaderSource->Lines->Text;}
  bool __fastcall Execute(TIModuleInterface **mi)
  { *mi=NULL; bool okay=true;
    TCreateModuleFlags mf;
    if (f->cAddToProject->Checked) mf << cmAddToProject;
    if (f->cShowSource->Checked) mf << cmShowSource;
    if (f->cShowForm->Checked) mf << cmShowForm;
    if (f->cUnNamed->Checked) mf << cmUnNamed;
    if (f->cNewUnit->Checked) mf << cmNewUnit;
    if (f->cNewForm->Checked) mf << cmNewForm;
    //if (cNewModel->Checked) mf << cmNewModel;
    if (f->cMainForm->Checked) mf << cmMainForm;
    if (f->cMarkModified->Checked) mf << cmMarkModified;
    if (f->cExisting->Checked) mf << cmExisting;
    try {*mi=ToolServices->ModuleCreateEx(this,mf);}
    catch (Exception &e)
    { Application->MessageBox((AnsiString(e.ClassName())+": "+e.Message).c_str(),"Error",MB_OK); okay=false;
    }
    return okay;
  }
};

void __fastcall TToolsForm::CreateModuleExClick(TObject *Sender)
{ TAutoModuleCreator *amc = new TAutoModuleCreator(this);
  TIModuleInterface *mi;
  amc->Execute(&mi);
  if (mi==NULL)
  { Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
  }
  else
  { TModuleForm *moduleform=new TModuleForm(this);
    moduleform->mi=mi;
    moduleform->Caption=ModuleName->Text;
    moduleform->ShowModal();
    delete moduleform;
    mi->Release();
  }
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetProjectNameClick(TObject *Sender)
{
rGetProjectName->Caption=tools->GetProjectName();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetUnitCountClick(TObject *Sender)
{
rGetUnitCount->Caption=AnsiString(tools->GetUnitCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetUnitNameClick(TObject *Sender)
{
rGetUnitName->Caption=tools->GetUnitName(tGetUnitName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormCountClick(TObject *Sender)
{
rGetFormCount->Caption=AnsiString(tools->GetFormCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormNameClick(TObject *Sender)
{
rGetFormName->Caption=tools->GetFormName(tGetFormName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetCurrentFileClick(TObject *Sender)
{
rGetCurrentFile->Caption=tools->GetCurrentFile();
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::IsFileOpenClick(TObject *Sender)
{
rIsFileOpen->Caption=tools->IsFileOpen(tIsFileOpen->Text) ? "true" : "false";
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetNewModuleNameClick(TObject *Sender)
{
AnsiString u,f;
rGetNewModuleName3->Caption=tools->GetNewModuleName(u,f) ? "true" : "false";
rGetNewModuleName1->Caption="unit:"+u;
rGetNewModuleName2->Caption="form:"+f;
}
//---------------------------------------------------------------------------
bool __stdcall EnumProc(void *Param,const AnsiString fl,const AnsiString u,const AnsiString fo)
{ TStringList *sl=(TStringList *)Param;
  AnsiString c="";
  if (fl!="") c=c+"file="+fl;
  if (u!="") {if (c!="") c=c+",    "; c=c+"unit="+u;}
  if (fo!="") {if (c!="") c=c+",    "; c=c+"form="+fo;}
  sl->Add(c);
  return true;
}
void __fastcall TToolsForm::EnumProjectUnitsClick(TObject *Sender)
{ TStringList *sl=new TStringList();
  tools->EnumProjectUnits(EnumProc,sl);
  rEnumProjectUnits->Items->Assign(sl);
  delete sl;
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::rEnumProjectUnitsClick(TObject *Sender)
{ if (rEnumProjectUnits->ItemIndex==-1) return;
  AnsiString s=rEnumProjectUnits->Items->Strings[rEnumProjectUnits->ItemIndex];
  int pos1,pos2; AnsiString t;
  pos1=s.Pos("file="); if (pos1==0) tGetModuleInterface->Text="";
  else
  { pos1=pos1+5; t=s.SubString(pos1,s.Length()-pos1+1); pos2=t.Pos(",");
    if (pos2!=0) t=t.SubString(1,pos2-1);
    tGetModuleInterface->Text=t;
  }
  pos1=s.Pos("form="); if (pos1==0) tGetFormModuleInterface->Text="";
  else
  { pos1=pos1+5; t=s.SubString(pos1,s.Length()-pos1+1); pos2=t.Pos(",");
    if (pos2!=0) t=t.SubString(1,pos2-1);
    tGetFormModuleInterface->Text=t;
  }
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::rEnumProjectUnitsDblClick(TObject *Sender)
{ AnsiString f=tGetFormModuleInterface->Text;
  if (f=="") GetModuleInterfaceClick(this);
  else GetFormModuleInterfaceClick(this);
}

//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleCountClick(TObject *Sender)
{
rGetModuleCount->Caption=AnsiString(tools->GetModuleCount());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleNameClick(TObject *Sender)
{
rGetModuleName->Caption=tools->GetModuleName(tGetModuleName->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetComponentCountClick(TObject *Sender)
{
rGetComponentCount->Caption=AnsiString(tools->GetComponentCount(tGetComponentCount->Text.ToInt()));
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetComponentNameClick(TObject *Sender)
{
rGetComponentName->Caption=tools->GetComponentName(tGetComponentName1->Text.ToInt(),tGetComponentName2->Text.ToInt());
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetModuleInterfaceClick(TObject *Sender)
{
TIModuleInterface *mi=tools->GetModuleInterface(tGetModuleInterface->Text);
if (mi==NULL)
{ Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
}
else
{ // probably not needed mi->AddRef();
  TModuleForm *moduleform=new TModuleForm(this);
  moduleform->mi=mi;
  moduleform->Caption=tGetModuleInterface->Text;
  moduleform->ShowModal();
  delete moduleform;
  mi->Release();
}
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::GetFormModuleInterfaceClick(TObject *Sender)
{ TIModuleInterface *mi=tools->GetFormModuleInterface(tGetFormModuleInterface->Text);
  if (mi==NULL)
  { Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
  }
  else
  { // mi->Addref probably not needed
    TModuleForm *moduleform=new TModuleForm(this);
    moduleform->mi=mi;
    moduleform->Caption=tGetFormModuleInterface->Text;
    moduleform->ShowModal();
    delete moduleform;
    mi->Release();
  }
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::FormCreate(TObject *Sender)
{ ToolPropSheet->ActivePage=tsQuick;
}
//---------------------------------------------------------------------------
void __fastcall TToolsForm::BtnAboutClick(TObject *Sender)
{ Application->MessageBox("Tools Services Browser is (c) 1997-2000 Lucian Wischik\r\n\r\n"
              "See README.TXT for more details. To contact the author, email ljw1004@cam.ac.uk "
              "or go to his C++Builder web page at www.wischik.com/lu/programmer.html",
              "Tool Services Browser",MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::GetMainMenuClick(TObject *Sender)
{
  TIMainMenuIntf *mmi=tools->GetMainMenu();
  if (mmi==NULL)
  { Application->MessageBox("Main menu doesn't exist","Error",MB_OK);
  }
  else
  { // mmi->Addref probably not needed
    TMainMenuForm *menuform=new TMainMenuForm(this);
    menuform->mmi=mmi;
    menuform->ShowModal();
    delete menuform;
    mmi->Release();
  }
}


//---------------------------------------------------------------------------

void __fastcall TToolsForm::btnAddNotifierClick(TObject *Sender)
{ TProjectNotifierForm *mn=new TProjectNotifierForm(Application);
  mn->Show();
}
//---------------------------------------------------------------------------

void __fastcall TToolsForm::btnResourcesClick(TObject *Sender)
{ AnsiString fn=ToolServices->GetProjectName();
  TIModuleInterface *mi=ToolServices->GetModuleInterface(fn);
  if (mi==NULL)
  { Application->MessageBox("Main project module not found","Error",MB_OK);
  }
  else
  { TIResourceFile *rf=mi->GetProjectResource();
    if (rf==NULL)
    { Application->MessageBox("Project Resource not found","Error",MB_OK);
    }
    else
    { TModuleForm *mf=new TModuleForm(this);
      mf->mi=mi; mf->Show();
      TResourceFileForm *f=new TResourceFileForm(this);
      f->rf=rf;
      f->ShowModal();
      rf->Release();
      mf->Hide(); mf->ShowModal();
    }
    mi->Release();
  }
}
//---------------------------------------------------------------------------

class TAutoProjectCreator : public TIProjectCreatorEx
{
public:
  TToolsForm *f;
  __fastcall TAutoProjectCreator(TToolsForm *af) : TIProjectCreatorEx() {f=af;}
  //
  bool __stdcall Existing() {return f->projExisting->Checked;}
  AnsiString __stdcall GetFileName() {return f->projfnSource->Text;}
  AnsiString __stdcall GetOptionName() {return f->projfnOption->Text;}
  AnsiString __stdcall NewProjectSource(AnsiString ProjectName) {return f->projSource->Lines->Text;}
  AnsiString __stdcall NewOptionSource(AnsiString ProjectName) {return f->projOption->Lines->Text;}
  AnsiString __stdcall GetFileSystem() {return f->projFileSystem->Text;}
  void __stdcall NewProjectResource(TIModuleInterface *mi) {mi->Release();}
  void __stdcall NewDefaultModule() {}
  bool __fastcall Execute(TIModuleInterface **mi)
  { *mi=NULL; bool okay=true;
    TCreateProjectFlags mf;
    if (f->projcpCustom->Checked) mf << cpCustom;
    if (f->projcpApplication->Checked) mf << cpApplication;
    if (f->projcpLibrary->Checked) mf << cpLibrary;
    if (f->projcpCanShowSource->Checked) mf << cpCanShowSource;
    if (f->projcpConsole->Checked) mf << cpConsole;
    try {*mi=ToolServices->ProjectCreateEx(this,mf);}
    catch (EAbort &e) {okay=false;}
    catch (Exception &e) {Application->MessageBox((AnsiString(e.ClassName())+": "+e.Message).c_str(),"Error",MB_OK); okay=false;}
    return okay;
  }
};

void __fastcall TToolsForm::CreateProjectExClick(TObject *Sender)
{ TAutoProjectCreator *apc = new TAutoProjectCreator(this);
  TIModuleInterface *mi;
  apc->Execute(&mi);
  if (mi==NULL)
  { Application->MessageBox("Module interface doesn't exist","Error",MB_OK);
  }
  else
  { TModuleForm *moduleform=new TModuleForm(this);
    moduleform->mi=mi;
    moduleform->Caption=ModuleName->Text;
    moduleform->ShowModal();
    delete moduleform;
    mi->Release();
  }
}
//---------------------------------------------------------------------------

